unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, TeeSurfa, ExtCtrls, TeeProcs, Chart, StdCtrls, Vcl.Buttons,
  Vcl.Menus;

Type
  TTriVals = record
    X,Y,Z : extended;
  end;

  TTriValsArray = Array of TTriVals;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TContourSeries;
    Panel1: TPanel;
    CheckBox_fill: TCheckBox;
    Button_LCWData: TButton;
    Button_TestSamplesselfcreated: TButton;
    Button3: TButton;
    CheckBox_smooth: TCheckBox;
    Button_AS_samples: TButton;
    Series4: TIsoSurfaceSeries;
    BB_save: TBitBtn;
    CB_AutomaticLevels: TCheckBox;
    L_Levels: TLabel;
    E_1: TEdit;
    procedure FormShow(Sender: TObject);
    procedure CheckBox_fillClick(Sender: TObject);
    procedure Button_LCWDataClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button_AS_samplesClick(Sender: TObject);
    procedure btn1Exit(Sender: TObject);
    procedure a1Click(Sender: TObject);
    procedure BB_saveClick(Sender: TObject);
    procedure CB_AutomaticLevelsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure E_1Exit(Sender: TObject);
    procedure E_1Change(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure Load_Values;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
uses StrUtils;

{$R *.dfm}
var SampleVals : TTriValsArray;
    Vals : TTriValsArray;


procedure ZerlegeStringFast1(const Zeile, Trennzeichen : String;
                                   OutStrings          : TStrings ;
                             const TrimSpalten         : Boolean = True;
                             const Leerspalten         : Boolean = True;
                             const forcecount          : Integer = -1);
var ZeileNeu   : string;
    Startpos   : integer;
    //Anzahl     : integer;
    FirstTrenn : integer;
    i, Laenge_Zeile, Laenge_Trenn : integer;
begin
  OutStrings.Clear; //Init

  ZeileNeu := Trim(Zeile);
  Laenge_Zeile := length(ZeileNeu);
  Laenge_Trenn := length(Trennzeichen);


  if (Laenge_Zeile = 0)  or (Laenge_Trenn = 0) or (Laenge_Trenn > Laenge_Zeile) then
  begin
    for i := 0 to forcecount-1 do OutStrings.Add('');
    Exit;
  end;

  Startpos := 1;
  //FirstTrenn := FastPos(ZeileNeu, Trennzeichen, Laenge_Zeile, Laenge_Trenn, Startpos);
  FirstTrenn := PosEx(Trennzeichen, ZeileNeu, Startpos);

  If Leerspalten then
  begin
    while FirstTrenn > 0 do
    begin
      if TrimSpalten then
        OutStrings.Add(trim(copy(ZeileNeu, Startpos, FirstTrenn - Startpos)))
      else
        OutStrings.Add(copy(ZeileNeu, Startpos, FirstTrenn - Startpos));

      //Startpos := FirstTrenn+1;
      Startpos := FirstTrenn+Laenge_Trenn;

      //FirstTrenn := FastPos(ZeileNeu, Trennzeichen, Laenge_Zeile, Laenge_Trenn, Startpos);
      FirstTrenn := PosEx(Trennzeichen, ZeileNeu, Startpos);
    end;

    If FirstTrenn = 0 then
    begin
      if TrimSpalten then
        OutStrings.Add(Trim(copy(ZeileNeu, Startpos, Laenge_Zeile+1 - Startpos)))
      else
        OutStrings.Add(copy(ZeileNeu, Startpos, Laenge_Zeile+1 - Startpos));
    end;
  end
  else
  begin
    while FirstTrenn > 0 do
    begin
      if TrimSpalten then
        OutStrings.Add(trim(copy(ZeileNeu, Startpos, FirstTrenn - Startpos)))
      else
        OutStrings.Add(copy(ZeileNeu, Startpos, FirstTrenn - Startpos));

      //dive 2008.06.27: alt i := FirstTrenn
      i := FirstTrenn;
      Repeat
        Inc(i,Laenge_Trenn);
      Until Copy(ZeileNeu,i,Laenge_Trenn) <> Trennzeichen;
      Startpos := i;

      //FirstTrenn := FastPos(ZeileNeu, Trennzeichen, Laenge_Zeile, Laenge_Trenn, Startpos);
      FirstTrenn := PosEx(Trennzeichen, ZeileNeu, Startpos);
    end;

    If FirstTrenn = 0 then
    begin
      if TrimSpalten then
        OutStrings.Add(trim(copy(ZeileNeu, Startpos, Laenge_Zeile+1 - Startpos)))
      else
        OutStrings.Add(copy(ZeileNeu, Startpos, Laenge_Zeile+1 - Startpos));
    end;
  end;

  if Forcecount<>-1 then
  begin
    while Outstrings.count < Forcecount do
      Outstrings.Add('');
    while Outstrings.count > Forcecount do
      Outstrings.Delete(Outstrings.count-1);
  end;
end;//ZerlegeStringFast1


procedure TForm1.Load_Values;
var i : integer;
    sl : TStrings;
    slRow : TStrings;
    x : double;
    xx : TColor;
begin
  Series1.clear;
  Series4.clear;

  sl := TStringlist.create;
  slRow := TStringlist.create;
  try
      sl.loadfromfile('.\LCW-Values.txt');

      setlength(Vals, sl.count);

      for i := 0 to sl.count -1 do
      begin
        zerlegestringfast1(sl[i], ';', slRow);
        Vals[i].X := strtofloatdef(slRow[0], 0);
        Vals[i].Y := strtofloatdef(slRow[1], 0);
        Vals[i].Z := strtofloatdef(slRow[2], 0);
      end;
  finally
    sl.free;
    slRow.free;
  end;

  //showmessage(inttostr(length(Vals)));
  for i := 0 to high(Vals) do
  begin
    Series1.AddXYZ(round(Vals[i].X), Vals[i].Z, round(Vals[i].Y));
    Series4.AddXYZ(round(Vals[i].X), Vals[i].Z, round(Vals[i].Y));
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Series1.NumLevels := 12;
  E_1.Text          := IntToStr(Series1.NumLevels);
end;

procedure TForm1.FormShow(Sender: TObject);
var i : integer;
begin
  CheckBox_fill.Checked := Series1.Brush.Style = bsSolid;
  Series1.FillSampleValues(100);
  Chart1.Repaint;
end;

{-------------------------------------------------------------------------------
  Author:    as (2012.02.08)
  Comment:
-------------------------------------------------------------------------------}
procedure TForm1.CB_AutomaticLevelsClick(Sender: TObject);
begin
   Button_LCWDataClick(Button_LCWData);
end;

procedure TForm1.CheckBox_fillClick(Sender: TObject);
begin
  If Sender = CheckBox_fill then
  begin
    If CheckBox_fill.checked then
      Series1.Brush.Style := bsSolid
    else
      Series1.Brush.Style := bsClear;

    Series4.Brush.Style := Series1.Brush.Style;
  end;

  If Sender = CheckBox_smooth then
  begin
    Series1.Smoothing.Active := CheckBox_smooth.Checked;
  end;
end;

procedure TForm1.E_1Change(Sender: TObject);
begin
  Series1.NumLevels := StrToIntDef(E_1.Text,12);
end;

procedure TForm1.E_1Exit(Sender: TObject);
var  num : Integer;
begin
   num := StrToIntDef(E_1.Text,12);
   E_1.Text := IntToStr(num);
end;

{-------------------------------------------------------------------------------
  Author:    as (2012.02.06)
  Comment:
-------------------------------------------------------------------------------}
procedure TForm1.Button_LCWDataClick(Sender: TObject);
var i : Integer;
begin
  //********************************************************************************
  // 1)
  If Sender = Button_LCWData then
  begin
    Chart1.LeftAxis.Automatic := False;
    Chart1.BottomAxis.Automatic := False;

    Chart1.LeftAxis.Minimum := 0;
    Chart1.LeftAxis.Maximum := 1337.5;

    Chart1.BottomAxis.Minimum := -1000;
    Chart1.BottomAxis.Maximum := +1000;

    if CB_AutomaticLevels.Checked then
      Series1.AutomaticLevels := True
    else
    begin
      for i := 0 to Series1.Levels.Count -1 do
        Series1.Levels[i].UpToValue := i * 5;
      Series1.AutomaticLevels := False;
    end;
    Series1.IrregularGrid := True;

    Load_Values; //Load values from external file
  end;
  //********************************************************************************
  // 2)
  If Sender = Button_TestSamplesselfcreated then
  begin
    Chart1.LeftAxis.Automatic := True;
    Chart1.BottomAxis.Automatic := True;

    Series1.AutomaticLevels := True;

    Series1.IrregularGrid := True;

    Series1.clear;
    Series1.FillSampleValues(10);

    Series4.clear;
    Series4.FillSampleValues(10);
  end;

end;
{-------------------------------------------------------------------------------
  Author:    as (2012.02.08)
  Comment:
-------------------------------------------------------------------------------}
procedure TForm1.a1Click(Sender: TObject);
begin
  ShowMessage('y<ccx');
end;

procedure TForm1.BB_saveClick(Sender: TObject);
begin
   Chart1.SaveToBitmapFile('d:\Temp\TChart.bmp');
end;

procedure TForm1.btn1Exit(Sender: TObject);
begin
  ShowMessage('hallo');
end;

procedure TForm1.Button3Click(Sender: TObject);
var i : integer;
    Arow : integer;
    sl : TStrings;
begin
  ARow := -1;
  Series1.clear;
  Chart1.LeftAxis.Automatic := True;
  Chart1.BottomAxis.Automatic := True;
  Series1.AutomaticLevels := True;

  //following example delivers matching borders and color regions: no fractional part in float values!
  Series1.AddXYZ(  1.000, 0.496, 1.000);
  Series1.AddXYZ(  2.000, 0.493, 1.000);
  Series1.AddXYZ(  3.000, 0.487, 1.000);
  Series1.AddXYZ(  4.000, 0.478, 1.000);
  Series1.AddXYZ(  5.000, 0.467, 1.000);
  Series1.AddXYZ(  6.000, 0.454, 1.000);
  Series1.AddXYZ(  7.000, 0.439, 1.000);
  Series1.AddXYZ(  8.000, 0.422, 1.000);
  Series1.AddXYZ(  9.000, 0.403, 1.000);
  Series1.AddXYZ( 10.000, 0.383, 1.000);
  Series1.AddXYZ( 11.000, 0.361, 1.000);
  Series1.AddXYZ(  1.000, 0.490, 2.000);
  Series1.AddXYZ(  2.000, 0.486, 2.000);
  Series1.AddXYZ(  3.000, 0.480, 2.000);
  Series1.AddXYZ(  4.000, 0.471, 2.000);
  Series1.AddXYZ(  5.000, 0.460, 2.000);
  Series1.AddXYZ(  6.000, 0.447, 2.000);
  Series1.AddXYZ(  7.000, 0.432, 2.000);
  Series1.AddXYZ(  8.000, 0.415, 2.000);
  Series1.AddXYZ(  9.000, 0.396, 2.000);
  Series1.AddXYZ( 10.000, 0.376, 2.000);
  Series1.AddXYZ( 11.000, 0.354, 2.000);

end;

procedure TForm1.Button_AS_samplesClick(Sender: TObject);
var i,j : integer;
begin
  Chart1.LeftAxis.Automatic := True;
  Chart1.BottomAxis.Automatic := True;
  Series1.AutomaticLevels := True;

//  Series1.IrregularGrid := true;
  Series1.IrregularGrid := False;
  Series1.clear;

  // Problem : Using float values for x or z the border lines and the color regions does not match!
  Series1.AddXYZ( 1.000, 0.496, 1.000);
  Series1.AddXYZ( 2.000, 0.493, 1.000);
  Series1.AddXYZ( 3.000, 0.487, 1.000);

  Series1.AddXYZ( 1.000, 0.490, 2.000);
  Series1.AddXYZ( 2.000, 0.485, 2.000);
  Series1.AddXYZ( 3.000, 0.480, 2.000);
//or even worser!
//  Series1.AddXYZ( 2.000, 0.386, 2.000);   //101
//  Series1.AddXYZ( 3.000, 0.382, 2.000);

end;

end.
